<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE mapper PUBLIC '-//mybatis.org//DTD Mapper 3.0//EN'
        'http://mybatis.org/dtd/mybatis-3-mapper.dtd'>

<mapper namespace='wat.sbd.i8e2s4.db.distributed.generator.postgres.mybatis.mappers.PostgresMapper'>

    <resultMap id="product" type="wat.sbd.i8e2s4.db.distributed.generator.model.Product" autoMapping="true">
        <association property="category"
                     javaType="wat.sbd.i8e2s4.db.distributed.generator.model.Category"
                     columnPrefix="category_"/>
    </resultMap>
    <insert id="insertCategory">
        <selectKey keyProperty="category.id" order="BEFORE" resultType="long">
            select nextval('category_seq')
        </selectKey>
        insert into kategoria (id_kategorii,
        nazwa,
        opis)
        values (#{category.id},
        #{category.name},
        #{category.description})
    </insert>
    <insert id="insertProduct">
        <selectKey keyProperty="product.id" order="BEFORE" resultType="long">
            select nextval('product_seq')
        </selectKey>
        insert into produkt (id_produktu,
        id_kategorii,
        nazwa,
        cena,
        opis)
        values (#{product.id},
        #{product.category.id},
        #{product.name},
        #{product.price},
        #{product.description})
    </insert>
    <insert id="insertRate">
        <selectKey keyProperty="rate.id" order="BEFORE" resultType="long">
            select nextval('rate_seq')
        </selectKey>
        insert into ocena (id_oceny,
        wartosc_oceny,
        komentarz)
        values (#{rate.id},
        #{rate.weight},
        #{rate.comment})
    </insert>
    <insert id="insertVendor">
        <selectKey keyProperty="vendor.id" order="BEFORE" resultType="long">
            select nextval('vendor_seq')
        </selectKey>
        insert into sprzedawca (id_sprzedawcy,
        nazwa_sprzedawcy,
        imie,
        nazwisko,
        data_dolaczenia)
        values (#{vendor.id},
        #{vendor.type},
        #{vendor.name},
        #{vendor.surname},
        #{vendor.joinDate})
    </insert>
    <insert id="insertTransaction">
        <selectKey keyProperty="transaction.id" order="BEFORE" resultType="long">
            select nextval('transaction_seq')
        </selectKey>
        insert into transakcja (id_transakcji,
        id_sprzedawcy,
        id_oceny,
        id_produktu,
        czas_transakcji)
        values (#{transaction.id},
        #{transaction.vendor.id},
        #{transaction.rate.id},
        #{transaction.product.id},
        #{transaction.date})
    </insert>


    <delete id="truncateTransactions">
        delete from transakcja
    </delete>
    <delete id="truncateProducts">
        delete from produkt
    </delete>
    <delete id="truncateCategories">
        delete from kategoria
    </delete>
    <delete id="truncateRates">
        delete from ocena
    </delete>
    <delete id="truncateVendors">
        delete from sprzedawca
    </delete>


    <select id="findAllCategories" resultType="wat.sbd.i8e2s4.db.distributed.generator.model.Category">
        select id_kategorii id,
               nazwa        "name",
               opis         description
        from kategoria
    </select>
    <select id="findAllRates" resultType="wat.sbd.i8e2s4.db.distributed.generator.model.Rate">
        select id_oceny      id,
               wartosc_oceny weight,
               komentarz     "comment"
        from ocena
    </select>
    <select id="findAllProducts" resultMap="product">
        select id_produktu    id,
               p.nazwa        "name",
               cena           price,
               p.opis         description,
               k.id_kategorii category_id,
               k.nazwa        category_name,
               k.opis         category_description
        from produkt p
                 inner join kategoria k on p.id_kategorii = k.id_kategorii
    </select>
    <select id="findAllVendors" resultType="wat.sbd.i8e2s4.db.distributed.generator.model.Vendor">
        select id_sprzedawcy    id,
               nazwa_sprzedawcy "type",
               imie             "name",
               nazwisko         surname,
               data_dolaczenia  join_date
        from sprzedawca
    </select>

</mapper>